﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Xna.Framework;

namespace Sensors {
  public partial class MainPage : PhoneApplicationPage {

    Microsoft.Devices.Sensors.Accelerometer Accelerometer;

    static int sample_size = 10;
    List<Vector3> vs = new List<Vector3>(sample_size);

    public MainPage() {
      InitializeComponent();

      for (int i = 0; i < sample_size; i++) {
        vs.Add(new Vector3());
      }

      Accelerometer = new Microsoft.Devices.Sensors.Accelerometer();
      Accelerometer.CurrentValueChanged += Accelerometer_CurrentvalueChanged;
      Accelerometer.Start();
    }

    void Accelerometer_CurrentvalueChanged(object sender, Microsoft.Devices.Sensors.SensorReadingEventArgs<Microsoft.Devices.Sensors.AccelerometerReading> e) {
      Vector3 tmp = e.SensorReading.Acceleration;

      Dispatcher.BeginInvoke(() => {
        x.Text = "X: " + tmp.X.ToString("0.00");
        y.Text = "Y: " + tmp.Y.ToString("0.00");
        z.Text = "Z: " + tmp.Z.ToString("0.00");

        //Ez nagyon ugrál:

        //Canvas.SetLeft(signText, 320 / 2 - tmp.X * 320);
        //Canvas.SetTop(signText, 240 / 2 + tmp.Y * 240);

        //Még akkor is, ha lerakjuk a telefont az asztalra és nem nyúlunk hozzá.

        //Számoljunk inkább átlagot...
        doAverage(tmp);
      });
    }

    void doAverage(Vector3 vec3) {
      //Replace latest reading with current.
      vs.RemoveAt(0);
      vs.Add(vec3);

      //Average
      double left = 0, top = 0;
      foreach (Vector3 v in vs) {
        left += v.X;
        top += v.Y;
      }

      left /= sample_size;
      top /= sample_size;

      //Most a -1 és 1 közötti kiátlagolt számot át kell alakítani koordinátákká:
      //Méretünk 320×240
      //x adja meg hol vagyunk 0..320 között jobbra
      //y adja meg hol vagyunk 0..240 között lefelé
      //Kell egy egyenlet, ami:
      //  f(-1) helyen 0-t ad,
      //  f(0) helyen 160-at ad, és
      //  f(1) helyen 320-at ad.
      double x = left + 1;
      //Most kell egy egyenlet, ami:
      //  f(0) helyen 0-t ad,
      //  f(1) helyen 160-at ad, és
      //  f(2) helyen 320-at ad.
      //Ez már könnyebben megy:
      x *= 320 / 2;
      //És y-ra hasonlóan:
      double y = (top + 1) * 240 / 2;
      Canvas.SetLeft(signText, x);
      Canvas.SetTop(signText, y);
    }
  }
}